import 'dart:io';
import 'package:path/path.dart' as path;

import 'package:wings_iconfont/utils.dart';

String readPath = 'assets/fonts/';
String writePath = 'lib/icons/';

void main(List<String> args) {
  if (args.length > 0) {
    readPath = args[0];
  }
  if (args.length > 1) {
    writePath = args[1];
  }

  start(readPath);
}

void start(String dirPath) {
  var dirList = Directory(dirPath).listSync(recursive: false, followLinks: true);

  var ttfPath = '';
  var jsonPath = '';

  for (var dir in dirList) {
    if (FileSystemEntity.isFileSync(dir.path)) {
      if (dir.path.endsWith('.json')) {
        jsonPath = dir.path;
      }
      if (dir.path.endsWith('.ttf')) {
        ttfPath = dir.path;
      }

      if (ttfPath.isNotEmpty && jsonPath.isNotEmpty) {
        var pathList = path.split(dir.path.replaceFirst(readPath, ''));
        var clazzName = (pathList..removeLast()).last;
        var savePath = '${path.joinAll([writePath, ...pathList])}.dart';
        saveFont(ttfPath, jsonPath, savePath, clazzName);
      }
    }

    if (FileSystemEntity.isDirectorySync(dir.path)) {
      start(dir.path);
    }
  }
}
